#include <sys/types.h>
#include <fcntl.h>
#include <stdio.h>

#include "config.h"

extern char curdir[];
extern int output;
extern char outputfile[];

int main( argc, argv )
int argc;
char *argv[];
{
	int fd, temp;
	int i, c;

	if( argc < 2 ) {
		fprintf( stderr, "Help for htlpr :  %s -h\n", argv[0] );
		return 1;
	}

	for( i = 1; i < argc; i++ ) {
		if( argv[i][0] == '-' ) 
			if( setoption( argv[i] ) < 0 ) {
				fprintf( stderr, "Unknown option %s\n", argv[i] );
				return 1;
			}
	}

	if( ( temp = opentemp() ) < 0 ) {
		fprintf( stderr, "Cannot open tempfile" );
		return 1;
	}
	for( i = 1; i < argc; i++ ) {
		if( argv[i][0] == '-' )                         /* If option, skip */
			continue;

		if( ( fd = open( argv[i], O_RDONLY ) ) < 0 ) {
			fprintf( stderr, "No Such a file %s.", argv[i] );
			return 1;
		}

		printf( "Converting to latex... " );
		if( ConvertToLatex( fd, temp ) < 0 ) {
			fprintf( stderr, "Unknown error.\n" );
			return 1;
		}
		close( fd );
		printf( "done\n" );
	}
	close( temp );

	getcwd( curdir, FILELENGTH );
	chdir( TMPDIR );
	printf( "Run hlatex ... " );
	if( DoExecuteLatex() < 0 )
		return 1; 
	printf( "done\n" );

	if( DoExecuteDvips() < 0 ) 
		return 1;

	if( output == PRN ) {
		if( DoPrint() < 0 ) 
			return 1;
	}
	else if( output == PS ) {
		if( DoPs() < 0 ) 
			return 1;
	}
	ClearTempFile();
}
